<template>
  <div
    id="app"
    class="small-container"
  >
    <h1>Books</h1>

    <BookForm @add:book="addBook" />
    <BookTable
      :books="books"
      @delete:book="deleteBook"
      @edit:book="editBook"
    />
  </div>
</template>

<script>
import BookTable from './components/BookTable';
import BookForm from './components/BookForm';

export default {
  name: "app",
  components: {
    BookTable,
    BookForm,
  },
  data() {
    return {
      books: []
    }
  },
  mounted() {
    this.getBooks()
  },
  methods: {
    // async getBooks() {
    //   try {
    //     const response = await fetch('')
    //     const data = await response.json()
    //     this.books = data
    //   } catch (error) {
    //     console.error(error)
    //   }
    // },
    async addBook(book) {
      try {
        const response = await fetch('https://jsonplaceholder.typicode.com/posts', {
          method: 'POST',
          body: JSON.stringify(book),
          headers: { "Content-type": "application/json; charset=UTF-8" }
        })
        const data = await response.json()
        this.books = [...this.books, data]
      } catch (error) {
        console.error(error)
      }
    },
    async editBook(id, updatedBook) {
      try {
        const response = await fetch(`https://jsonplaceholder.typicode.com/posts/${id}`, {
          method: 'PUT',
          body: JSON.stringify(updatedBook),
          headers: { "Content-type": "application/json; charset=UTF-8" }
        })
        const data = await response.json()
        this.books = this.books.map(book => book.id === id ? data : book)
      } catch (error) {
        console.error(error)
      }
    },
    async deleteBook(id) {
      try {
        await fetch(`https://jsonplaceholder.typicode.com/posts/${id}`, {
          method: 'DELETE'
        })
        this.books = this.books.filter(book => book.id !== id)
      } catch (error) {
        console.error(error)
      }
    },
  },
}
</script>

<style>
button {
  background: #009435;
  border: 1px solid #009435;
}
button:hover,
button:active,
button:focus {
  background: #32a95d;
  border: 1px solid #32a95d;
}
.small-container {
  max-width: 680px;
}
</style>